/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "vncharacterconversation.h"

void _vnCharacterConversationTalkingOn(
  vnconversation_t *convo, vnconversationtext_t *text
) {
  vncharacter_t *character = (vncharacter_t *)text->data;
  character->talking = true;
  vnConversationNext(convo);
}
void _vnCharacterConversationTalkingOff(
  vnconversation_t *convo, vnconversationtext_t *text
) {
  vncharacter_t *character = (vncharacter_t *)text->data;
  character->talking = false;
  vnConversationNext(convo);
}

vnconversationtext_t * vnCharacterConversationSetTalking(
  vncharacter_t *character, vnconversation_t *conversation, bool talking
) {
  vnconversationtext_t *text;
  text = vnConversationAdd(conversation);
  text->data = character;
  text->onStart = talking ? (
    &_vnCharacterConversationTalkingOn 
  ) : &_vnCharacterConversationTalkingOff;
  return text;
}